Create sandbox
curl --request POST \
--url https://api.e2b.app/sandboxes \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
{
"templateID": "<string>",
"timeout": 15,
"cpuCount": 2,
"autoPause": false,
"autoPauseMemory": true,
"secure": true,
"allow_internet_access": true,
"network": {
"allowPublicTraffic": true,
"allowOut": [
"<string>"
],
"denyOut": [
"<string>"
],
"dnsServers": [
"<string>"
],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": true,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [
32768
],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": {
"tokens": {}
},
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
'import requests
url = "https://api.e2b.app/sandboxes"
payload = {
"templateID": "<string>",
"timeout": 15,
"cpuCount": 2,
"autoPause": False,
"autoPauseMemory": True,
"secure": True,
"allow_internet_access": True,
"network": {
"allowPublicTraffic": True,
"allowOut": ["<string>"],
"denyOut": ["<string>"],
"dnsServers": ["<string>"],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": True,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [32768],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": { "tokens": {} },
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
templateID: '<string>',
timeout: 15,
cpuCount: 2,
autoPause: false,
autoPauseMemory: true,
secure: true,
allow_internet_access: true,
network: {
allowPublicTraffic: true,
allowOut: ['<string>'],
denyOut: ['<string>'],
dnsServers: ['<string>'],
egressProxy: {
address: '<string>',
username: '<string>',
password: '<string>',
tls: {enabled: true, serverName: '<string>', caCert: '<string>'}
},
maskRequestHost: '<string>',
httpsPorts: [32768],
rules: {}
},
metadata: {},
envVars: {},
mcp: {},
iam: {tokens: {}},
volumeMounts: [{name: '<string>', path: '<string>'}]
})
};
fetch('https://api.e2b.app/sandboxes', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.e2b.app/sandboxes",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'templateID' => '<string>',
'timeout' => 15,
'cpuCount' => 2,
'autoPause' => false,
'autoPauseMemory' => true,
'secure' => true,
'allow_internet_access' => true,
'network' => [
'allowPublicTraffic' => true,
'allowOut' => [
'<string>'
],
'denyOut' => [
'<string>'
],
'dnsServers' => [
'<string>'
],
'egressProxy' => [
'address' => '<string>',
'username' => '<string>',
'password' => '<string>',
'tls' => [
'enabled' => true,
'serverName' => '<string>',
'caCert' => '<string>'
]
],
'maskRequestHost' => '<string>',
'httpsPorts' => [
32768
],
'rules' => [
]
],
'metadata' => [
],
'envVars' => [
],
'mcp' => [
],
'iam' => [
'tokens' => [
]
],
'volumeMounts' => [
[
'name' => '<string>',
'path' => '<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.e2b.app/sandboxes"
payload := strings.NewReader("{\n \"templateID\": \"<string>\",\n \"timeout\": 15,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"secure\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.e2b.app/sandboxes")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"templateID\": \"<string>\",\n \"timeout\": 15,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"secure\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.e2b.app/sandboxes")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"templateID\": \"<string>\",\n \"timeout\": 15,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"secure\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"templateID": "<string>",
"sandboxID": "<string>",
"clientID": "<string>",
"envdVersion": "<string>",
"alias": "<string>",
"envdAccessToken": "<string>",
"trafficAccessToken": "<string>",
"domain": "<string>"
}
Sandboxes
Create sandbox
deprecated
Create a sandbox from the template. All system communication with the sandbox is secured. Use POST /v2/sandboxes instead.
POST
/
sandboxes
Create sandbox
curl --request POST \
--url https://api.e2b.app/sandboxes \
--header 'Content-Type: application/json' \
--header 'X-API-Key: <api-key>' \
--data '
{
"templateID": "<string>",
"timeout": 15,
"cpuCount": 2,
"autoPause": false,
"autoPauseMemory": true,
"secure": true,
"allow_internet_access": true,
"network": {
"allowPublicTraffic": true,
"allowOut": [
"<string>"
],
"denyOut": [
"<string>"
],
"dnsServers": [
"<string>"
],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": true,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [
32768
],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": {
"tokens": {}
},
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
'import requests
url = "https://api.e2b.app/sandboxes"
payload = {
"templateID": "<string>",
"timeout": 15,
"cpuCount": 2,
"autoPause": False,
"autoPauseMemory": True,
"secure": True,
"allow_internet_access": True,
"network": {
"allowPublicTraffic": True,
"allowOut": ["<string>"],
"denyOut": ["<string>"],
"dnsServers": ["<string>"],
"egressProxy": {
"address": "<string>",
"username": "<string>",
"password": "<string>",
"tls": {
"enabled": True,
"serverName": "<string>",
"caCert": "<string>"
}
},
"maskRequestHost": "<string>",
"httpsPorts": [32768],
"rules": {}
},
"metadata": {},
"envVars": {},
"mcp": {},
"iam": { "tokens": {} },
"volumeMounts": [
{
"name": "<string>",
"path": "<string>"
}
]
}
headers = {
"X-API-Key": "<api-key>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {'X-API-Key': '<api-key>', 'Content-Type': 'application/json'},
body: JSON.stringify({
templateID: '<string>',
timeout: 15,
cpuCount: 2,
autoPause: false,
autoPauseMemory: true,
secure: true,
allow_internet_access: true,
network: {
allowPublicTraffic: true,
allowOut: ['<string>'],
denyOut: ['<string>'],
dnsServers: ['<string>'],
egressProxy: {
address: '<string>',
username: '<string>',
password: '<string>',
tls: {enabled: true, serverName: '<string>', caCert: '<string>'}
},
maskRequestHost: '<string>',
httpsPorts: [32768],
rules: {}
},
metadata: {},
envVars: {},
mcp: {},
iam: {tokens: {}},
volumeMounts: [{name: '<string>', path: '<string>'}]
})
};
fetch('https://api.e2b.app/sandboxes', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.e2b.app/sandboxes",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'templateID' => '<string>',
'timeout' => 15,
'cpuCount' => 2,
'autoPause' => false,
'autoPauseMemory' => true,
'secure' => true,
'allow_internet_access' => true,
'network' => [
'allowPublicTraffic' => true,
'allowOut' => [
'<string>'
],
'denyOut' => [
'<string>'
],
'dnsServers' => [
'<string>'
],
'egressProxy' => [
'address' => '<string>',
'username' => '<string>',
'password' => '<string>',
'tls' => [
'enabled' => true,
'serverName' => '<string>',
'caCert' => '<string>'
]
],
'maskRequestHost' => '<string>',
'httpsPorts' => [
32768
],
'rules' => [
]
],
'metadata' => [
],
'envVars' => [
],
'mcp' => [
],
'iam' => [
'tokens' => [
]
],
'volumeMounts' => [
[
'name' => '<string>',
'path' => '<string>'
]
]
]),
CURLOPT_HTTPHEADER => [
"Content-Type: application/json",
"X-API-Key: <api-key>"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.e2b.app/sandboxes"
payload := strings.NewReader("{\n \"templateID\": \"<string>\",\n \"timeout\": 15,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"secure\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("X-API-Key", "<api-key>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.e2b.app/sandboxes")
.header("X-API-Key", "<api-key>")
.header("Content-Type", "application/json")
.body("{\n \"templateID\": \"<string>\",\n \"timeout\": 15,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"secure\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.e2b.app/sandboxes")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["X-API-Key"] = '<api-key>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"templateID\": \"<string>\",\n \"timeout\": 15,\n \"cpuCount\": 2,\n \"autoPause\": false,\n \"autoPauseMemory\": true,\n \"secure\": true,\n \"allow_internet_access\": true,\n \"network\": {\n \"allowPublicTraffic\": true,\n \"allowOut\": [\n \"<string>\"\n ],\n \"denyOut\": [\n \"<string>\"\n ],\n \"dnsServers\": [\n \"<string>\"\n ],\n \"egressProxy\": {\n \"address\": \"<string>\",\n \"username\": \"<string>\",\n \"password\": \"<string>\",\n \"tls\": {\n \"enabled\": true,\n \"serverName\": \"<string>\",\n \"caCert\": \"<string>\"\n }\n },\n \"maskRequestHost\": \"<string>\",\n \"httpsPorts\": [\n 32768\n ],\n \"rules\": {}\n },\n \"metadata\": {},\n \"envVars\": {},\n \"mcp\": {},\n \"iam\": {\n \"tokens\": {}\n },\n \"volumeMounts\": [\n {\n \"name\": \"<string>\",\n \"path\": \"<string>\"\n }\n ]\n}"
response = http.request(request)
puts response.read_body{
"templateID": "<string>",
"sandboxID": "<string>",
"clientID": "<string>",
"envdVersion": "<string>",
"alias": "<string>",
"envdAccessToken": "<string>",
"trafficAccessToken": "<string>",
"domain": "<string>"
}
Body
application/json
Controls the snapshot kind taken when the sandbox auto-pauses on timeout (only relevant when autoPause is true). When false, the auto-pause drops the in-memory state and persists only the filesystem (a filesystem-only snapshot); resuming it cold-boots (reboots) the sandbox from disk. Such a snapshot cannot be auto-resumed by traffic and must be resumed explicitly, so it cannot be combined with autoResume. Defaults to true (full memory snapshot).
Response
The sandbox was created successfully
Was this page helpful?